blob: a30d46ed0b3b12c057f5125bb88c32409b2ae3a5 [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
3# Copyright 2015 The Chromium OS Authors. All rights reserved.
4# Use of this source code is governed by a BSD-style license that can be
5# found in the LICENSE file.
6
7# Script to generate a Brillo update for use by the update engine.
8#
9# usage: brillo_update_payload COMMAND [ARGS]
10# The following commands are supported:
11# generate generate an unsigned payload
12# hash generate a payload or metadata hash
13# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080014# properties generate a properties file from a payload
Jason Kusumabe998f42015-09-03 15:53:13 -070015#
16# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070017# --payload generated unsigned payload output file
18# --source_image if defined, generate a delta payload from the specified
19# image to the target_image
20# --target_image the target image that should be sent to clients
21# --metadata_size_file if defined, generate a file containing the size of the payload
22# metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070023#
24# Hash command arguments:
25# --unsigned_payload the input unsigned payload to generate the hash from
26# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070027# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070028# --payload_hash_file if defined, generate a payload hash and output to the
29# specified file
30# --metadata_hash_file if defined, generate a metadata hash and output to the
31# specified file
32#
33# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070034# --unsigned_payload the input unsigned payload to insert the signatures
35# --payload the output signed payload
36# --signature_size signature sizes in bytes in the following format:
37# "size1:size2[:...]"
38# --payload_signature_file the payload signature files in the following
39# format:
40# "payload_signature1:payload_signature2[:...]"
41# --metadata_signature_file the metadata signature files in the following
42# format:
43# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070044# --metadata_size_file if defined, generate a file containing the size of
45# the signed payload metadata in bytes to the
46# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070047# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080048#
49# Properties command arguments:
50# --payload the input signed or unsigned payload
51# --properties_file the output path where to write the properties, or
52# '-' for stdout.
53
Jason Kusumabe998f42015-09-03 15:53:13 -070054
Alex Deymo61e1fa82016-01-19 15:16:34 -080055# Exit codes:
56EX_UNSUPPORTED_DELTA=100
57
Jason Kusumaf514c542015-11-05 18:43:45 -080058warn() {
59 echo "brillo_update_payload: warning: $*" >&2
60}
61
Gilad Arnold957ce122015-10-14 16:02:55 -070062die() {
63 echo "brillo_update_payload: error: $*" >&2
64 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070065}
66
Gilad Arnold957ce122015-10-14 16:02:55 -070067# Loads shflags. We first look at the default install location; then look for
68# crosutils (chroot); finally check our own directory (au-generator zipfile).
69load_shflags() {
70 local my_dir="$(dirname "$(readlink -f "$0")")"
71 local path
72 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
73 if [[ -r "${path}/shflags" ]]; then
74 . "${path}/shflags" || die "Could not load ${path}/shflags."
75 return
76 fi
77 done
78 die "Could not find shflags."
79}
80
81load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -070082
Alex Deymoc64ffd52015-09-25 18:10:07 -070083HELP_GENERATE="generate: Generate an unsigned update payload."
84HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
85for signing."
86HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -080087HELP_PROPERTIES="properties: Extract payload properties to a file."
Alex Deymoc64ffd52015-09-25 18:10:07 -070088
89usage() {
90 echo "Supported commands:"
91 echo
92 echo "${HELP_GENERATE}"
93 echo "${HELP_HASH}"
94 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -080095 echo "${HELP_PROPERTIES}"
Alex Deymoc64ffd52015-09-25 18:10:07 -070096 echo
97 echo "Use: \"$0 <command> --help\" for more options."
98}
99
100# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700101if [[ $# -lt 1 ]]; then
Alex Deymo98e691c2016-02-04 21:05:45 -0800102 echo "Please specify a command [generate|hash|sign|properties]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700103 exit 1
104fi
105
Alex Deymoc64ffd52015-09-25 18:10:07 -0700106# Parse command.
107COMMAND="${1:-}"
108shift
109
110case "${COMMAND}" in
111 generate)
112 FLAGS_HELP="${HELP_GENERATE}"
113 ;;
114
115 hash)
116 FLAGS_HELP="${HELP_HASH}"
117 ;;
118
119 sign)
120 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700121 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800122
123 properties)
124 FLAGS_HELP="${HELP_PROPERTIES}"
125 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700126 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700127 echo "Unrecognized command: \"${COMMAND}\"" >&2
128 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130 ;;
131esac
132
Jason Kusumabe998f42015-09-03 15:53:13 -0700133# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700134FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
135${FLAGS_HELP}"
136
137if [[ "${COMMAND}" == "generate" ]]; then
138 DEFINE_string payload "" \
139 "Path to output the generated unsigned payload file."
140 DEFINE_string target_image "" \
141 "Path to the target image that should be sent to clients."
142 DEFINE_string source_image "" \
143 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700144 DEFINE_string metadata_size_file "" \
145 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700146fi
147if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
148 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
149 DEFINE_string signature_size "" \
150 "Signature sizes in bytes in the following format: size1:size2[:...]"
151fi
152if [[ "${COMMAND}" == "hash" ]]; then
153 DEFINE_string metadata_hash_file "" \
154 "Optional: Path to output metadata hash file."
155 DEFINE_string payload_hash_file "" \
156 "Optional: Path to output payload hash file."
157fi
158if [[ "${COMMAND}" == "sign" ]]; then
159 DEFINE_string payload "" \
160 "Path to output the generated unsigned payload file."
161 DEFINE_string metadata_signature_file "" \
162 "The metatada signatures in the following format: \
163metadata_signature1:metadata_signature2[:...]"
164 DEFINE_string payload_signature_file "" \
165 "The payload signatures in the following format: \
166payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700167 DEFINE_string metadata_size_file "" \
168 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800170if [[ "${COMMAND}" == "properties" ]]; then
171 DEFINE_string payload "" \
172 "Path to the input signed or unsigned payload file."
173 DEFINE_string properties_file "-" \
174 "Path to output the extracted property files. If '-' is passed stdout will \
175be used."
176fi
177
Jason Kusumabe998f42015-09-03 15:53:13 -0700178DEFINE_string work_dir "/tmp" "Where to dump temporary files."
179
180# Parse command line flag arguments
181FLAGS "$@" || exit 1
182eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700183set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700184
Alex Deymo89ff9e32015-09-15 19:29:01 -0700185# Associative arrays from partition name to file in the source and target
186# images. The size of the updated area must be the size of the file.
187declare -A SRC_PARTITIONS
188declare -A DST_PARTITIONS
189
190# A list of temporary files to remove during cleanup.
191CLEANUP_FILES=()
192
Alex Deymo48b502a2015-09-17 19:00:18 -0700193# Global options to force the version of the payload.
194FORCE_MAJOR_VERSION=""
195FORCE_MINOR_VERSION=""
196
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800197# Path to the postinstall config file in target image if exists.
198POSTINSTALL_CONFIG_FILE=""
199
Alex Deymoc97df432015-09-25 17:23:52 -0700200# read_option_int <file.txt> <option_key> [default_value]
201#
202# Reads the unsigned integer value associated with |option_key| in a key=value
203# file |file.txt|. Prints the read value if found and valid, otherwise prints
204# the |default_value|.
205read_option_uint() {
206 local file_txt="$1"
207 local option_key="$2"
208 local default_value="${3:-}"
209 local value
210 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
211 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
212 echo "${value}"
213 return
214 fi
215 fi
216 echo "${default_value}"
217}
218
Alex Deymo89ff9e32015-09-15 19:29:01 -0700219# Create a temporary file in the work_dir with an optional pattern name.
220# Prints the name of the newly created file.
221create_tempfile() {
222 local pattern="${1:-tempfile.XXXXXX}"
223 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
224}
Jason Kusumabe998f42015-09-03 15:53:13 -0700225
226cleanup() {
227 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700228 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700229
230 # If we are cleaning up after an error, or if we got an error during
231 # cleanup (even if we eventually succeeded) return a non-zero exit
232 # code. This triggers additional logging in most environments that call
233 # this script.
234 if [[ -n "${err}" ]]; then
235 die "Cleanup encountered an error."
236 fi
237}
238
239cleanup_on_error() {
240 trap - INT TERM ERR EXIT
241 cleanup
242 die "Cleanup success after an error."
243}
244
245cleanup_on_exit() {
246 trap - INT TERM ERR EXIT
247 cleanup
248}
249
250trap cleanup_on_error INT TERM ERR
251trap cleanup_on_exit EXIT
252
Alex Deymo48b502a2015-09-17 19:00:18 -0700253
254# extract_image <image> <partitions_array>
255#
256# Detect the format of the |image| file and extract its updatable partitions
257# into new temporary files. Add the list of partition names and its files to the
258# associative array passed in |partitions_array|.
259extract_image() {
260 local image="$1"
261
262 # Brillo images are zip files. We detect the 4-byte magic header of the zip
263 # file.
264 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
265 if [[ "${magic}" == "504b0304" ]]; then
266 echo "Detected .zip file, extracting Brillo image."
267 extract_image_brillo "$@"
268 return
269 fi
270
271 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
272 # bundled here and we will use it to extract the partitions, so the GPT
273 # headers must be valid.
274 if cgpt show -q -n "${image}" >/dev/null; then
275 echo "Detected GPT image, extracting Chrome OS image."
276 extract_image_cros "$@"
277 return
278 fi
279
280 die "Couldn't detect the image format of ${image}"
281}
282
Alex Deymo89ff9e32015-09-15 19:29:01 -0700283# extract_image_cros <image.bin> <partitions_array>
284#
Alex Deymo48b502a2015-09-17 19:00:18 -0700285# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700286extract_image_cros() {
287 local image="$1"
288 local partitions_array="$2"
289
290 local kernel root
291 kernel=$(create_tempfile "kernel.bin.XXXXXX")
292 CLEANUP_FILES+=("${kernel}")
293 root=$(create_tempfile "root.bin.XXXXXX")
294 CLEANUP_FILES+=("${root}")
295
296 cros_generate_update_payload --extract \
297 --image "${image}" \
298 --kern_path "${kernel}" --root_path "${root}" \
299 --work_dir "${FLAGS_work_dir}" --outside_chroot
300
Alex Deymo83f2f702015-10-14 14:49:33 -0700301 # Chrome OS uses major_version 1 payloads for all versions, even if the
302 # updater supports a newer major version.
303 FORCE_MAJOR_VERSION="1"
304
Alex Deymo48b502a2015-09-17 19:00:18 -0700305 # When generating legacy Chrome OS images, we need to use "boot" and "system"
306 # for the partition names to be compatible with updating Brillo devices with
307 # Chrome OS images.
308 eval ${partitions_array}[boot]=\""${kernel}"\"
309 eval ${partitions_array}[system]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700310
311 local part varname
Alex Deymo48b502a2015-09-17 19:00:18 -0700312 for part in boot system; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700313 varname="${partitions_array}[${part}]"
314 printf "md5sum of %s: " "${varname}"
315 md5sum "${!varname}"
316 done
317}
318
Alex Deymo48b502a2015-09-17 19:00:18 -0700319# extract_image_brillo <target_files.zip> <partitions_array>
320#
321# Extract the A/B updated partitions from a Brillo target_files zip file into
322# new temporary files.
323extract_image_brillo() {
324 local image="$1"
325 local partitions_array="$2"
326
Alex Deymo48b502a2015-09-17 19:00:18 -0700327 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800328 local ab_partitions_list
329 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
330 CLEANUP_FILES+=("${ab_partitions_list}")
331 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
332 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
333 die "Invalid partition names found in the partition list."
334 fi
335 partitions=($(cat "${ab_partitions_list}"))
336 if [[ ${#partitions[@]} -eq 0 ]]; then
337 die "The list of partitions is empty. Can't generate a payload."
338 fi
339 else
340 warn "No ab_partitions.txt found. Using default."
341 fi
342 echo "List of A/B partitions: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700343
Alex Deymo83f2f702015-10-14 14:49:33 -0700344 # All Brillo updaters support major version 2.
345 FORCE_MAJOR_VERSION="2"
346
Alex Deymo48b502a2015-09-17 19:00:18 -0700347 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800348 # Source image
349 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700350 CLEANUP_FILES+=("${ue_config}")
351 if ! unzip -p "${image}" "META/update_engine_config.txt" \
352 >"${ue_config}"; then
353 warn "No update_engine_config.txt found. Assuming pre-release image, \
354using payload minor version 2"
355 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700356 # For delta payloads, we use the major and minor version supported by the
357 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700358 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
359 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700360 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
361 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800362
363 # Brillo support for deltas started with minor version 3.
364 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
365 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
366Disabling deltas for this source version."
367 exit ${EX_UNSUPPORTED_DELTA}
368 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800369 else
370 # Target image
371 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
372 CLEANUP_FILES+=("${postinstall_config}")
373 if unzip -p "${image}" "META/postinstall_config.txt" \
374 >"${postinstall_config}"; then
375 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
376 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700377 fi
378
379 local part part_file temp_raw filesize
380 for part in "${partitions[@]}"; do
381 part_file=$(create_tempfile "${part}.img.XXXXXX")
382 CLEANUP_FILES+=("${part_file}")
383 unzip -p "${image}" "IMAGES/${part}.img" >"${part_file}"
384
385 # If the partition is stored as an Android sparse image file, we need to
386 # convert them to a raw image for the update.
387 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
388 if [[ "${magic}" == "3aff26ed" ]]; then
389 temp_raw=$(create_tempfile "${part}.raw.XXXXXX")
390 CLEANUP_FILES+=("${temp_raw}")
391 echo "Converting Android sparse image ${part}.img to RAW."
392 simg2img "${part_file}" "${temp_raw}"
393 # At this point, we can drop the contents of the old part_file file, but
394 # we can't delete the file because it will be deleted in cleanup.
395 true >"${part_file}"
396 part_file="${temp_raw}"
397 fi
398
399 # delta_generator only supports images multiple of 4 KiB, so we pad with
400 # zeros if needed.
401 filesize=$(stat -c%s "${part_file}")
402 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
403 echo "Rounding up partition ${part}.img to multiple of 4 KiB."
404 : $(( filesize = (filesize + 4095) & -4096 ))
405 truncate --size="${filesize}" "${part_file}"
406 fi
407
408 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
409 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
410 done
411}
412
Jason Kusumabe998f42015-09-03 15:53:13 -0700413validate_generate() {
414 [[ -n "${FLAGS_payload}" ]] ||
415 die "Error: you must specify an output filename with --payload FILENAME"
416
417 [[ -n "${FLAGS_target_image}" ]] ||
418 die "Error: you must specify a target image with --target_image FILENAME"
419}
420
421cmd_generate() {
Alex Deymo89ff9e32015-09-15 19:29:01 -0700422 local payload_type="delta"
Jason Kusumabe998f42015-09-03 15:53:13 -0700423 if [[ -z "${FLAGS_source_image}" ]]; then
Alex Deymo89ff9e32015-09-15 19:29:01 -0700424 payload_type="full"
Jason Kusumabe998f42015-09-03 15:53:13 -0700425 fi
426
Alex Deymo48b502a2015-09-17 19:00:18 -0700427 echo "Extracting images for ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700428
Alex Deymo48b502a2015-09-17 19:00:18 -0700429 extract_image "${FLAGS_target_image}" DST_PARTITIONS
Alex Deymo89ff9e32015-09-15 19:29:01 -0700430 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo48b502a2015-09-17 19:00:18 -0700431 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
Jason Kusumabe998f42015-09-03 15:53:13 -0700432 fi
433
Alex Deymo48b502a2015-09-17 19:00:18 -0700434 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800435 # Common payload args:
436 GENERATOR_ARGS=( -out_file="${FLAGS_payload}" )
437
438 local part old_partitions="" new_partitions="" partition_names=""
439 for part in "${!DST_PARTITIONS[@]}"; do
440 if [[ -n "${partition_names}" ]]; then
441 partition_names+=":"
442 new_partitions+=":"
443 old_partitions+=":"
444 fi
445 partition_names+="${part}"
446 new_partitions+="${DST_PARTITIONS[${part}]}"
447 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
448 done
449
450 # Target image args:
451 GENERATOR_ARGS+=(
452 -partition_names="${partition_names}"
453 -new_partitions="${new_partitions}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700454 )
455
Alex Deymo89ff9e32015-09-15 19:29:01 -0700456 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800457 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700458 GENERATOR_ARGS+=(
Alex Deymo168b5352015-11-04 13:51:52 -0800459 -old_partitions="${old_partitions}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700460 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700461 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
462 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
463 fi
464 fi
465
466 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
467 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700468 fi
469
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700470 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
471 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
472 fi
473
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800474 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
475 GENERATOR_ARGS+=(
476 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
477 )
478 fi
479
Jason Kusumabe998f42015-09-03 15:53:13 -0700480 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700481 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700482
Alex Deymo89ff9e32015-09-15 19:29:01 -0700483 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700484}
485
486validate_hash() {
487 [[ -n "${FLAGS_signature_size}" ]] ||
488 die "Error: you must specify signature size with --signature_size SIZES"
489
490 [[ -n "${FLAGS_unsigned_payload}" ]] ||
491 die "Error: you must specify the input unsigned payload with \
492--unsigned_payload FILENAME"
493
Jason Kusumabe998f42015-09-03 15:53:13 -0700494 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiangbf1266f2015-10-26 11:29:24 -0700495 die "Error: you must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800496
497 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
498 die "Error: you must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700499}
500
501cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700502 "${GENERATOR}" \
503 -in_file="${FLAGS_unsigned_payload}" \
504 -signature_size="${FLAGS_signature_size}" \
505 -out_hash_file="${FLAGS_payload_hash_file}" \
506 -out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700507
Jason Kusumabe998f42015-09-03 15:53:13 -0700508 echo "Done generating hash."
509}
510
511validate_sign() {
512 [[ -n "${FLAGS_signature_size}" ]] ||
513 die "Error: you must specify signature size with --signature_size SIZES"
514
515 [[ -n "${FLAGS_unsigned_payload}" ]] ||
516 die "Error: you must specify the input unsigned payload with \
517--unsigned_payload FILENAME"
518
519 [[ -n "${FLAGS_payload}" ]] ||
520 die "Error: you must specify the output signed payload with \
521--payload FILENAME"
522
523 [[ -n "${FLAGS_payload_signature_file}" ]] ||
524 die "Error: you must specify the payload signature file with \
525--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700526
527 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
528 die "Error: you must specify the metadata signature file with \
529--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700530}
531
532cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700533 GENERATOR_ARGS=(
534 -in_file="${FLAGS_unsigned_payload}"
535 -signature_size="${FLAGS_signature_size}"
536 -signature_file="${FLAGS_payload_signature_file}"
537 -metadata_signature_file="${FLAGS_metadata_signature_file}"
538 -out_file="${FLAGS_payload}"
539 )
540
541 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
542 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
543 fi
544
545 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700546 echo "Done signing payload."
547}
548
Alex Deymo98e691c2016-02-04 21:05:45 -0800549validate_properties() {
550 [[ -n "${FLAGS_payload}" ]] ||
551 die "Error: you must specify the payload file with --payload FILENAME"
552
553 [[ -n "${FLAGS_properties_file}" ]] ||
554 die "Error: you must specify a non empty --properties_file FILENAME"
555}
556
557cmd_properties() {
558 "${GENERATOR}" \
559 -in_file="${FLAGS_payload}" \
560 -properties_file="${FLAGS_properties_file}"
561}
562
Jason Kusumabe998f42015-09-03 15:53:13 -0700563# Sanity check that the real generator exists:
564GENERATOR="$(which delta_generator)"
565[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
566
567case "$COMMAND" in
568 generate) validate_generate
569 cmd_generate
570 ;;
571 hash) validate_hash
572 cmd_hash
573 ;;
574 sign) validate_sign
575 cmd_sign
576 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800577 properties) validate_properties
578 cmd_properties
579 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700580esac